# azure.mgmt.compute.v2015_06_15.operations module

class `azure.mgmt.compute.v2015_06_15.operations.``AvailabilitySetsOperations`(client, config, serializer, deserializer)

  Bases: `object`

  AvailabilitySetsOperations operations.

  You should not instantiate directly this class, but create a Client instance that will create it for you and attach it as attribute.

  Parameters:

  - client – Client for service requests.
  - config – Configuration of service client.
  - serializer – An object model serializer.
  - deserializer – An object model deserializer.

  Variables: | api_version – Client Api Version. Constant value: “2015-06-15”.

  `create_or_update`(resource_group_name, name, parameters, custom_headers=None, raw=False, **operation_config)

    Create or update an availability set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - name (str) – The name of the availability set.
    - parameters (AvailabilitySet) – Parameters supplied to the Create Availability Set operation.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | AvailabilitySet or ClientRawResponse if raw=true
    Return type: | AvailabilitySet or ClientRawResponse
    Raises: | `CloudError`

  `delete`(resource_group_name, availability_set_name, custom_headers=None, raw=False, **operation_config)

    Delete an availability set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - availability_set_name (str) – The name of the availability set.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | OperationStatusResponse or ClientRawResponse if raw=true
    Return type: | OperationStatusResponse or ClientRawResponse
    Raises: | `CloudError`

  `get`(resource_group_name, availability_set_name, custom_headers=None, raw=False, **operation_config)

    Retrieves information about an availability set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - availability_set_name (str) – The name of the availability set.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | AvailabilitySet or ClientRawResponse if raw=true
    Return type: | AvailabilitySet or ClientRawResponse
    Raises: | `CloudError`

  `list`(resource_group_name, custom_headers=None, raw=False, **operation_config)

    Lists all availability sets in a resource group.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | An iterator like instance of AvailabilitySet
    Return type: | AvailabilitySetPaged[AvailabilitySet]
    Raises: | `CloudError`

  `list_available_sizes`(resource_group_name, availability_set_name, custom_headers=None, raw=False, **operation_config)

    Lists all available virtual machine sizes that can be used to create a new virtual machine in an existing availability set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - availability_set_name (str) – The name of the availability set.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | An iterator like instance of VirtualMachineSize
    Return type: | VirtualMachineSizePaged[VirtualMachineSize]
    Raises: | `CloudError`

  `models` = <module 'azure.mgmt.compute.v2015_06_15.models' from '/usr/lib/python3/dist-packages/azure/mgmt/compute/v2015_06_15/models/__init__.py'>

class `azure.mgmt.compute.v2015_06_15.operations.``VirtualMachineExtensionImagesOperations`(client, config, serializer, deserializer)

  Bases: `object`

  VirtualMachineExtensionImagesOperations operations.

  You should not instantiate directly this class, but create a Client instance that will create it for you and attach it as attribute.

  Parameters:

  - client – Client for service requests.
  - config – Configuration of service client.
  - serializer – An object model serializer.
  - deserializer – An object model deserializer.

  Variables: | api_version – Client Api Version. Constant value: “2015-06-15”.

  `get`(location, publisher_name, type, version, custom_headers=None, raw=False, **operation_config)

    Gets a virtual machine extension image.

    Parameters:

    - location (str) – The name of a supported Azure region.
    - publisher_name (str) –
    - type (str) –
    - version (str) –
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | VirtualMachineExtensionImage or ClientRawResponse if raw=true
    Return type: | VirtualMachineExtensionImage or ClientRawResponse
    Raises: | `CloudError`

  `list_types`(location, publisher_name, custom_headers=None, raw=False, **operation_config)

    Gets a list of virtual machine extension image types.

    Parameters:

    - location (str) – The name of a supported Azure region.
    - publisher_name (str) –
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | list or ClientRawResponse if raw=true
    Return type: | list[VirtualMachineExtensionImage] or ClientRawResponse
    Raises: | `CloudError`

  `list_versions`(location, publisher_name, type, filter=None, top=None, orderby=None, custom_headers=None, raw=False, **operation_config)

    Gets a list of virtual machine extension image versions.

    Parameters:

    - location (str) – The name of a supported Azure region.
    - publisher_name (str) –
    - type (str) –
    - filter (str) – The filter to apply on the operation.
    - top (int) –
    - orderby (str) –
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | list or ClientRawResponse if raw=true
    Return type: | list[VirtualMachineExtensionImage] or ClientRawResponse
    Raises: | `CloudError`

  `models` = <module 'azure.mgmt.compute.v2015_06_15.models' from '/usr/lib/python3/dist-packages/azure/mgmt/compute/v2015_06_15/models/__init__.py'>

class `azure.mgmt.compute.v2015_06_15.operations.``VirtualMachineExtensionsOperations`(client, config, serializer, deserializer)

  Bases: `object`

  VirtualMachineExtensionsOperations operations.

  You should not instantiate directly this class, but create a Client instance that will create it for you and attach it as attribute.

  Parameters:

  - client – Client for service requests.
  - config – Configuration of service client.
  - serializer – An object model serializer.
  - deserializer – An object model deserializer.

  Variables: | api_version – Client Api Version. Constant value: “2015-06-15”.

  `create_or_update`(resource_group_name, vm_name, vm_extension_name, extension_parameters, custom_headers=None, raw=False, polling=True, **operation_config)

    The operation to create or update the extension.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine where the extension should be created or updated.
    - vm_extension_name (str) – The name of the virtual machine extension.
    - extension_parameters (VirtualMachineExtension) – Parameters supplied to the Create Virtual Machine Extension operation.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns VirtualMachineExtension or ClientRawResponse<VirtualMachineExtension> if raw==True
    Return type: | AzureOperationPoller[VirtualMachineExtension] or AzureOperationPoller[ClientRawResponse[VirtualMachineExtension]]
    Raises: | `CloudError`

  `delete`(resource_group_name, vm_name, vm_extension_name, custom_headers=None, raw=False, polling=True, **operation_config)

    The operation to delete the extension.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine where the extension should be deleted.
    - vm_extension_name (str) – The name of the virtual machine extension.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `get`(resource_group_name, vm_name, vm_extension_name, expand=None, custom_headers=None, raw=False, **operation_config)

    The operation to get the extension.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine containing the extension.
    - vm_extension_name (str) – The name of the virtual machine extension.
    - expand (str) – The expand expression to apply on the operation.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | VirtualMachineExtension or ClientRawResponse if raw=true
    Return type: | VirtualMachineExtension or ClientRawResponse
    Raises: | `CloudError`

  `update`(resource_group_name, vm_name, vm_extension_name, extension_parameters, custom_headers=None, raw=False, polling=True, **operation_config)

    The operation to update the extension.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine where the extension should be updated.
    - vm_extension_name (str) – The name of the virtual machine extension.
    - extension_parameters (VirtualMachineExtensionUpdate) – Parameters supplied to the Update Virtual Machine Extension operation.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns VirtualMachineExtension or ClientRawResponse<VirtualMachineExtension> if raw==True
    Return type: | AzureOperationPoller[VirtualMachineExtension] or AzureOperationPoller[ClientRawResponse[VirtualMachineExtension]]
    Raises: | `CloudError`

  `models` = <module 'azure.mgmt.compute.v2015_06_15.models' from '/usr/lib/python3/dist-packages/azure/mgmt/compute/v2015_06_15/models/__init__.py'>

class `azure.mgmt.compute.v2015_06_15.operations.``VirtualMachineImagesOperations`(client, config, serializer, deserializer)

  Bases: `object`

  VirtualMachineImagesOperations operations.

  You should not instantiate directly this class, but create a Client instance that will create it for you and attach it as attribute.

  Parameters:

  - client – Client for service requests.
  - config – Configuration of service client.
  - serializer – An object model serializer.
  - deserializer – An object model deserializer.

  Variables: | api_version – Client Api Version. Constant value: “2015-06-15”.

  `get`(location, publisher_name, offer, skus, version, custom_headers=None, raw=False, **operation_config)

    Gets a virtual machine image.

    Parameters:

    - location (str) – The name of a supported Azure region.
    - publisher_name (str) – A valid image publisher.
    - offer (str) – A valid image publisher offer.
    - skus (str) – A valid image SKU.
    - version (str) – A valid image SKU version.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | VirtualMachineImage or ClientRawResponse if raw=true
    Return type: | VirtualMachineImage or ClientRawResponse
    Raises: | `CloudError`

  `list`(location, publisher_name, offer, skus, filter=None, top=None, orderby=None, custom_headers=None, raw=False, **operation_config)

    Gets a list of all virtual machine image versions for the specified location, publisher, offer, and SKU.

    Parameters:

    - location (str) – The name of a supported Azure region.
    - publisher_name (str) – A valid image publisher.
    - offer (str) – A valid image publisher offer.
    - skus (str) – A valid image SKU.
    - filter (str) – The filter to apply on the operation.
    - top (int) –
    - orderby (str) –
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | list or ClientRawResponse if raw=true
    Return type: | list[VirtualMachineImageResource] or ClientRawResponse
    Raises: | `CloudError`

  `list_offers`(location, publisher_name, custom_headers=None, raw=False, **operation_config)

    Gets a list of virtual machine image offers for the specified location and publisher.

    Parameters:

    - location (str) – The name of a supported Azure region.
    - publisher_name (str) – A valid image publisher.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | list or ClientRawResponse if raw=true
    Return type: | list[VirtualMachineImageResource] or ClientRawResponse
    Raises: | `CloudError`

  `list_publishers`(location, custom_headers=None, raw=False, **operation_config)

    Gets a list of virtual machine image publishers for the specified Azure location.

    Parameters:

    - location (str) – The name of a supported Azure region.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | list or ClientRawResponse if raw=true
    Return type: | list[VirtualMachineImageResource] or ClientRawResponse
    Raises: | `CloudError`

  `list_skus`(location, publisher_name, offer, custom_headers=None, raw=False, **operation_config)

    Gets a list of virtual machine image SKUs for the specified location, publisher, and offer.

    Parameters:

    - location (str) – The name of a supported Azure region.
    - publisher_name (str) – A valid image publisher.
    - offer (str) – A valid image publisher offer.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | list or ClientRawResponse if raw=true
    Return type: | list[VirtualMachineImageResource] or ClientRawResponse
    Raises: | `CloudError`

  `models` = <module 'azure.mgmt.compute.v2015_06_15.models' from '/usr/lib/python3/dist-packages/azure/mgmt/compute/v2015_06_15/models/__init__.py'>

class `azure.mgmt.compute.v2015_06_15.operations.``UsageOperations`(client, config, serializer, deserializer)

  Bases: `object`

  UsageOperations operations.

  You should not instantiate directly this class, but create a Client instance that will create it for you and attach it as attribute.

  Parameters:

  - client – Client for service requests.
  - config – Configuration of service client.
  - serializer – An object model serializer.
  - deserializer – An object model deserializer.

  Variables: | api_version – Client Api Version. Constant value: “2015-06-15”.

  `list`(location, custom_headers=None, raw=False, **operation_config)

    Gets, for the specified location, the current compute resource usage information as well as the limits for compute resources under the subscription.

    Parameters:

    - location (str) – The location for which resource usage is queried.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | An iterator like instance of Usage
    Return type: | UsagePaged[Usage]
    Raises: | `CloudError`

  `models` = <module 'azure.mgmt.compute.v2015_06_15.models' from '/usr/lib/python3/dist-packages/azure/mgmt/compute/v2015_06_15/models/__init__.py'>

class `azure.mgmt.compute.v2015_06_15.operations.``VirtualMachineSizesOperations`(client, config, serializer, deserializer)

  Bases: `object`

  VirtualMachineSizesOperations operations.

  You should not instantiate directly this class, but create a Client instance that will create it for you and attach it as attribute.

  Parameters:

  - client – Client for service requests.
  - config – Configuration of service client.
  - serializer – An object model serializer.
  - deserializer – An object model deserializer.

  Variables: | api_version – Client Api Version. Constant value: “2015-06-15”.

  `list`(location, custom_headers=None, raw=False, **operation_config)

    Lists all available virtual machine sizes for a subscription in a location.

    Parameters:

    - location (str) – The location upon which virtual-machine-sizes is queried.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | An iterator like instance of VirtualMachineSize
    Return type: | VirtualMachineSizePaged[VirtualMachineSize]
    Raises: | `CloudError`

  `models` = <module 'azure.mgmt.compute.v2015_06_15.models' from '/usr/lib/python3/dist-packages/azure/mgmt/compute/v2015_06_15/models/__init__.py'>

class `azure.mgmt.compute.v2015_06_15.operations.``VirtualMachinesOperations`(client, config, serializer, deserializer)

  Bases: `object`

  VirtualMachinesOperations operations.

  You should not instantiate directly this class, but create a Client instance that will create it for you and attach it as attribute.

  Parameters:

  - client – Client for service requests.
  - config – Configuration of service client.
  - serializer – An object model serializer.
  - deserializer – An object model deserializer.

  Variables: | api_version – Client Api Version. Constant value: “2015-06-15”.

  `capture`(resource_group_name, vm_name, parameters, custom_headers=None, raw=False, polling=True, **operation_config)

    Captures the VM by copying virtual hard disks of the VM and outputs a template that can be used to create similar VMs.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine.
    - parameters (VirtualMachineCaptureParameters) – Parameters supplied to the Capture Virtual Machine operation.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns VirtualMachineCaptureResult or ClientRawResponse<VirtualMachineCaptureResult> if raw==True
    Return type: | AzureOperationPoller[VirtualMachineCaptureResult] or AzureOperationPoller[ClientRawResponse[VirtualMachineCaptureResult]]
    Raises: | `CloudError`

  `create_or_update`(resource_group_name, vm_name, parameters, custom_headers=None, raw=False, polling=True, **operation_config)

    The operation to create or update a virtual machine.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine.
    - parameters (VirtualMachine) – Parameters supplied to the Create Virtual Machine operation.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns VirtualMachine or ClientRawResponse<VirtualMachine> if raw==True
    Return type: | AzureOperationPoller[VirtualMachine] or AzureOperationPoller[ClientRawResponse[VirtualMachine]]
    Raises: | `CloudError`

  `deallocate`(resource_group_name, vm_name, custom_headers=None, raw=False, polling=True, **operation_config)

    Shuts down the virtual machine and releases the compute resources. You are not billed for the compute resources that this virtual machine uses.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `delete`(resource_group_name, vm_name, custom_headers=None, raw=False, polling=True, **operation_config)

    The operation to delete a virtual machine.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `generalize`(resource_group_name, vm_name, custom_headers=None, raw=False, **operation_config)

    Sets the state of the virtual machine to generalized.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | OperationStatusResponse or ClientRawResponse if raw=true
    Return type: | OperationStatusResponse or ClientRawResponse
    Raises: | `CloudError`

  `get`(resource_group_name, vm_name, expand=None, custom_headers=None, raw=False, **operation_config)

    Retrieves information about the model view or the instance view of a virtual machine.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine.
    - expand (str or InstanceViewTypes) – The expand expression to apply on the operation. Possible values include: ‘instanceView’
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | VirtualMachine or ClientRawResponse if raw=true
    Return type: | VirtualMachine or ClientRawResponse
    Raises: | `CloudError`

  `list`(resource_group_name, custom_headers=None, raw=False, **operation_config)

    Lists all of the virtual machines in the specified resource group. Use the nextLink property in the response to get the next page of virtual machines.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | An iterator like instance of VirtualMachine
    Return type: | VirtualMachinePaged[VirtualMachine]
    Raises: | `CloudError`

  `list_all`(custom_headers=None, raw=False, **operation_config)

    Lists all of the virtual machines in the specified subscription. Use the nextLink property in the response to get the next page of virtual machines.

    Parameters:

    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | An iterator like instance of VirtualMachine
    Return type: | VirtualMachinePaged[VirtualMachine]
    Raises: | `CloudError`

  `list_available_sizes`(resource_group_name, vm_name, custom_headers=None, raw=False, **operation_config)

    Lists all available virtual machine sizes to which the specified virtual machine can be resized.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | An iterator like instance of VirtualMachineSize
    Return type: | VirtualMachineSizePaged[VirtualMachineSize]
    Raises: | `CloudError`

  `power_off`(resource_group_name, vm_name, custom_headers=None, raw=False, polling=True, **operation_config)

    The operation to power off (stop) a virtual machine. The virtual machine can be restarted with the same provisioned resources. You are still charged for this virtual machine.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `redeploy`(resource_group_name, vm_name, custom_headers=None, raw=False, polling=True, **operation_config)

    Shuts down the virtual machine, moves it to a new node, and powers it back on.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `restart`(resource_group_name, vm_name, custom_headers=None, raw=False, polling=True, **operation_config)

    The operation to restart a virtual machine.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `start`(resource_group_name, vm_name, custom_headers=None, raw=False, polling=True, **operation_config)

    The operation to start a virtual machine.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_name (str) – The name of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `models` = <module 'azure.mgmt.compute.v2015_06_15.models' from '/usr/lib/python3/dist-packages/azure/mgmt/compute/v2015_06_15/models/__init__.py'>

class `azure.mgmt.compute.v2015_06_15.operations.``VirtualMachineScaleSetsOperations`(client, config, serializer, deserializer)

  Bases: `object`

  VirtualMachineScaleSetsOperations operations.

  You should not instantiate directly this class, but create a Client instance that will create it for you and attach it as attribute.

  Parameters:

  - client – Client for service requests.
  - config – Configuration of service client.
  - serializer – An object model serializer.
  - deserializer – An object model deserializer.

  Variables: | api_version – Client Api Version. Constant value: “2015-06-15”.

  `create_or_update`(resource_group_name, name, parameters, custom_headers=None, raw=False, polling=True, **operation_config)

    Create or update a VM scale set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - name (str) – The name of the VM scale set to create or update.
    - parameters (VirtualMachineScaleSet) – The scale set object.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns VirtualMachineScaleSet or ClientRawResponse<VirtualMachineScaleSet> if raw==True
    Return type: | AzureOperationPoller[VirtualMachineScaleSet] or AzureOperationPoller[ClientRawResponse[VirtualMachineScaleSet]]
    Raises: | `CloudError`

  `deallocate`(resource_group_name, vm_scale_set_name, instance_ids=None, custom_headers=None, raw=False, polling=True, **operation_config)

    Deallocates specific virtual machines in a VM scale set. Shuts down the virtual machines and releases the compute resources. You are not billed for the compute resources that this virtual machine scale set deallocates.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - instance_ids (list[str]) – The virtual machine scale set instance ids. Omitting the virtual machine scale set instance ids will result in the operation being performed on all virtual machines in the virtual machine scale set.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `delete`(resource_group_name, vm_scale_set_name, custom_headers=None, raw=False, polling=True, **operation_config)

    Deletes a VM scale set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `delete_instances`(resource_group_name, vm_scale_set_name, instance_ids, custom_headers=None, raw=False, polling=True, **operation_config)

    Deletes virtual machines in a VM scale set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - instance_ids (list[str]) – The virtual machine scale set instance ids.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `get`(resource_group_name, vm_scale_set_name, custom_headers=None, raw=False, **operation_config)

    Display information about a virtual machine scale set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | VirtualMachineScaleSet or ClientRawResponse if raw=true
    Return type: | VirtualMachineScaleSet or ClientRawResponse
    Raises: | `CloudError`

  `get_instance_view`(resource_group_name, vm_scale_set_name, custom_headers=None, raw=False, **operation_config)

    Gets the status of a VM scale set instance.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | VirtualMachineScaleSetInstanceView or ClientRawResponse if raw=true
    Return type: | VirtualMachineScaleSetInstanceView or ClientRawResponse
    Raises: | `CloudError`

  `list`(resource_group_name, custom_headers=None, raw=False, **operation_config)

    Gets a list of all VM scale sets under a resource group.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | An iterator like instance of VirtualMachineScaleSet
    Return type: | VirtualMachineScaleSetPaged[VirtualMachineScaleSet]
    Raises: | `CloudError`

  `list_all`(custom_headers=None, raw=False, **operation_config)

    Gets a list of all VM Scale Sets in the subscription, regardless of the associated resource group. Use nextLink property in the response to get the next page of VM Scale Sets. Do this till nextLink is null to fetch all the VM Scale Sets.

    Parameters:

    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | An iterator like instance of VirtualMachineScaleSet
    Return type: | VirtualMachineScaleSetPaged[VirtualMachineScaleSet]
    Raises: | `CloudError`

  `list_skus`(resource_group_name, vm_scale_set_name, custom_headers=None, raw=False, **operation_config)

    Gets a list of SKUs available for your VM scale set, including the minimum and maximum VM instances allowed for each SKU.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | An iterator like instance of VirtualMachineScaleSetSku
    Return type: | VirtualMachineScaleSetSkuPaged[VirtualMachineScaleSetSku]
    Raises: | `CloudError`

  `power_off`(resource_group_name, vm_scale_set_name, instance_ids=None, custom_headers=None, raw=False, polling=True, **operation_config)

    Power off (stop) one or more virtual machines in a VM scale set. Note that resources are still attached and you are getting charged for the resources. Instead, use deallocate to release resources and avoid charges.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - instance_ids (list[str]) – The virtual machine scale set instance ids. Omitting the virtual machine scale set instance ids will result in the operation being performed on all virtual machines in the virtual machine scale set.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `reimage`(resource_group_name, vm_scale_set_name, custom_headers=None, raw=False, polling=True, **operation_config)

    Reimages (upgrade the operating system) one or more virtual machines in a VM scale set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `restart`(resource_group_name, vm_scale_set_name, instance_ids=None, custom_headers=None, raw=False, polling=True, **operation_config)

    Restarts one or more virtual machines in a VM scale set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - instance_ids (list[str]) – The virtual machine scale set instance ids. Omitting the virtual machine scale set instance ids will result in the operation being performed on all virtual machines in the virtual machine scale set.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `start`(resource_group_name, vm_scale_set_name, instance_ids=None, custom_headers=None, raw=False, polling=True, **operation_config)

    Starts one or more virtual machines in a VM scale set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - instance_ids (list[str]) – The virtual machine scale set instance ids. Omitting the virtual machine scale set instance ids will result in the operation being performed on all virtual machines in the virtual machine scale set.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `update_instances`(resource_group_name, vm_scale_set_name, instance_ids, custom_headers=None, raw=False, polling=True, **operation_config)

    Upgrades one or more virtual machines to the latest SKU set in the VM scale set model.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - instance_ids (list[str]) – The virtual machine scale set instance ids.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `models` = <module 'azure.mgmt.compute.v2015_06_15.models' from '/usr/lib/python3/dist-packages/azure/mgmt/compute/v2015_06_15/models/__init__.py'>

class `azure.mgmt.compute.v2015_06_15.operations.``VirtualMachineScaleSetVMsOperations`(client, config, serializer, deserializer)

  Bases: `object`

  VirtualMachineScaleSetVMsOperations operations.

  You should not instantiate directly this class, but create a Client instance that will create it for you and attach it as attribute.

  Parameters:

  - client – Client for service requests.
  - config – Configuration of service client.
  - serializer – An object model serializer.
  - deserializer – An object model deserializer.

  Variables: | api_version – Client Api Version. Constant value: “2015-06-15”.

  `deallocate`(resource_group_name, vm_scale_set_name, instance_id, custom_headers=None, raw=False, polling=True, **operation_config)

    Deallocates a specific virtual machine in a VM scale set. Shuts down the virtual machine and releases the compute resources it uses. You are not billed for the compute resources of this virtual machine once it is deallocated.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - instance_id (str) – The instance ID of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `delete`(resource_group_name, vm_scale_set_name, instance_id, custom_headers=None, raw=False, polling=True, **operation_config)

    Deletes a virtual machine from a VM scale set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - instance_id (str) – The instance ID of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `get`(resource_group_name, vm_scale_set_name, instance_id, custom_headers=None, raw=False, **operation_config)

    Gets a virtual machine from a VM scale set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - instance_id (str) – The instance ID of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | VirtualMachineScaleSetVM or ClientRawResponse if raw=true
    Return type: | VirtualMachineScaleSetVM or ClientRawResponse
    Raises: | `CloudError`

  `get_instance_view`(resource_group_name, vm_scale_set_name, instance_id, custom_headers=None, raw=False, **operation_config)

    Gets the status of a virtual machine from a VM scale set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - instance_id (str) – The instance ID of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | VirtualMachineScaleSetVMInstanceView or ClientRawResponse if raw=true
    Return type: | VirtualMachineScaleSetVMInstanceView or ClientRawResponse
    Raises: | `CloudError`

  `list`(resource_group_name, virtual_machine_scale_set_name, filter=None, select=None, expand=None, custom_headers=None, raw=False, **operation_config)

    Gets a list of all virtual machines in a VM scale sets.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - virtual_machine_scale_set_name (str) – The name of the VM scale set.
    - filter (str) – The filter to apply to the operation.
    - select (str) – The list parameters.
    - expand (str) – The expand expression to apply to the operation.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – returns the direct response alongside the deserialized response
    - operation_config – Operation configuration overrides.

    Returns: | An iterator like instance of VirtualMachineScaleSetVM
    Return type: | VirtualMachineScaleSetVMPaged[VirtualMachineScaleSetVM]
    Raises: | `CloudError`

  `power_off`(resource_group_name, vm_scale_set_name, instance_id, custom_headers=None, raw=False, polling=True, **operation_config)

    Power off (stop) a virtual machine in a VM scale set. Note that resources are still attached and you are getting charged for the resources. Instead, use deallocate to release resources and avoid charges.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - instance_id (str) – The instance ID of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `reimage`(resource_group_name, vm_scale_set_name, instance_id, custom_headers=None, raw=False, polling=True, **operation_config)

    Reimages (upgrade the operating system) a specific virtual machine in a VM scale set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - instance_id (str) – The instance ID of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `restart`(resource_group_name, vm_scale_set_name, instance_id, custom_headers=None, raw=False, polling=True, **operation_config)

    Restarts a virtual machine in a VM scale set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - instance_id (str) – The instance ID of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `start`(resource_group_name, vm_scale_set_name, instance_id, custom_headers=None, raw=False, polling=True, **operation_config)

    Starts a virtual machine in a VM scale set.

    Parameters:

    - resource_group_name (str) – The name of the resource group.
    - vm_scale_set_name (str) – The name of the VM scale set.
    - instance_id (str) – The instance ID of the virtual machine.
    - custom_headers (dict) – headers that will be added to the request
    - raw (bool) – The poller return type is ClientRawResponse, the direct response alongside the deserialized response
    - polling – True for ARMPolling, False for no polling, or a polling object for personal polling strategy

    Returns: | An instance of LROPoller that returns OperationStatusResponse or ClientRawResponse<OperationStatusResponse> if raw==True
    Return type: | AzureOperationPoller[OperationStatusResponse] or AzureOperationPoller[ClientRawResponse[OperationStatusResponse]]
    Raises: | `CloudError`

  `models` = <module 'azure.mgmt.compute.v2015_06_15.models' from '/usr/lib/python3/dist-packages/azure/mgmt/compute/v2015_06_15/models/__init__.py'>